/* XDS v2.51: Copyright (c) 1999-2003 Excelsior, LLC. All Rights Reserved. */
/* "@(#)ComplexMath.c May 10 15:18:12 2005" */
/* Generated by XDS Modula-2 to ANSI C v4.20 translator */

#define X2C_int32
#define X2C_index32
#ifndef ComplexMath_H_
#include "ComplexMath.h"
#endif
#define ComplexMath_C_
#ifndef EXCEPTIONS_H_
#include "EXCEPTIONS.h"
#endif
#ifndef RealMath_H_
#include "RealMath.h"
#endif

X2C_LONGCOMPLEX ComplexMath_i = {0.0,1.0};
X2C_LONGCOMPLEX ComplexMath_one = {1.0,0.0};
X2C_LONGCOMPLEX ComplexMath_zero = {0.0,0.0};
#define ComplexMath_name "ComplexMath."

#define ComplexMath_pi 3.141592

static EXCEPTIONS_ExceptionSource source;


extern X2C_REAL ComplexMath_abs(X2C_COMPLEX z)
{
   return RealMath_sqrt(z.re*z.re+z.im*z.im);
} /* end abs() */


extern X2C_REAL ComplexMath_arg(X2C_COMPLEX z)
{
   X2C_REAL im;
   X2C_REAL re;
   re = z.re;
   im = z.im;
   if (re>0.0f) return RealMath_arctan(X2C_DIVR(im,re));
   if (re<0.0f) {
      if (z.im>=0.0f) return RealMath_arctan(X2C_DIVR(im,re))+3.141592f;
      else return RealMath_arctan(X2C_DIVR(im,re))-3.141592f;
   }
   if (im==0.0f) {
      EXCEPTIONS_RAISE(source, 0ul, "ComplexMath.arg: zero argument", 31ul);
   }
   else if (im>0.0f) return 1.570796f;
   else return (-1.570796f);
   X2C_TRAP(X2C_RETURN_TRAP);
   return 0;
} /* end arg() */


extern X2C_COMPLEX ComplexMath_conj(X2C_COMPLEX z)
{
   X2C_COMPLEX tmp;
   return (tmp.re = z.re,tmp.im = -z.im,tmp);
} /* end conj() */

static X2C_COMPLEX _cnst = {0.0,0.0};

extern X2C_COMPLEX ComplexMath_power(X2C_COMPLEX base, X2C_REAL exponent)
{
   X2C_REAL y;
   X2C_REAL x;
   X2C_COMPLEX tmp;
   if (CPLX_CMP(base,_cnst)==0 && exponent>0.0f) return _cnst;
   x = RealMath_power(ComplexMath_abs(base), exponent);
   y = exponent*ComplexMath_arg(base);
   return (tmp.re = x*RealMath_cos(y),tmp.im = x*RealMath_sin(y),tmp);
} /* end power() */


extern X2C_COMPLEX ComplexMath_sqrt(X2C_COMPLEX z)
{
   X2C_REAL y;
   X2C_REAL x;
   X2C_COMPLEX tmp;
   if (CPLX_CMP(z,_cnst)==0) return z;
   x = RealMath_sqrt(ComplexMath_abs(z));
   y = X2C_DIVR(ComplexMath_arg(z),2.0f);
   return (tmp.re = x*RealMath_cos(y),tmp.im = x*RealMath_sin(y),tmp);
} /* end sqrt() */


extern X2C_COMPLEX ComplexMath_exp(X2C_COMPLEX z)
{
   X2C_REAL x;
   X2C_COMPLEX tmp;
   x = RealMath_exp(z.re);
   return (tmp.re = x*RealMath_cos(z.im),tmp.im = x*RealMath_sin(z.im),tmp);
} /* end exp() */


extern X2C_COMPLEX ComplexMath_ln(X2C_COMPLEX z)
{
   X2C_COMPLEX tmp;
   return (tmp.re = RealMath_ln(ComplexMath_abs(z)),
                tmp.im = ComplexMath_arg(z),tmp);
} /* end ln() */


extern X2C_COMPLEX ComplexMath_sin(X2C_COMPLEX z)
{
   X2C_REAL emb;
   X2C_REAL eb;
   X2C_COMPLEX tmp;
   eb = RealMath_exp(z.im);
   emb = X2C_DIVR(1.0f,eb);
   return (tmp.re = X2C_DIVR(RealMath_sin(z.re)*(emb+eb),2.0f),
                tmp.im = -(0.5f*RealMath_cos(z.re)*(emb-eb)),tmp);
} /* end sin() */


extern X2C_COMPLEX ComplexMath_cos(X2C_COMPLEX z)
{
   X2C_REAL emb;
   X2C_REAL eb;
   X2C_COMPLEX tmp;
   eb = RealMath_exp(z.im);
   emb = X2C_DIVR(1.0f,eb);
   return (tmp.re = X2C_DIVR(RealMath_cos(z.re)*(emb+eb),2.0f),
                tmp.im = X2C_DIVR(RealMath_sin(z.re)*(emb-eb),2.0f),tmp);
} /* end cos() */


extern X2C_COMPLEX ComplexMath_tan(X2C_COMPLEX z)
{
   X2C_REAL y;
   X2C_REAL x;
   X2C_REAL emb;
   X2C_REAL eb;
   X2C_REAL cos0;
   X2C_REAL sin0;
   X2C_COMPLEX tmp;
   if (CPLX_CMP(z,_cnst)==0) return _cnst;
   sin0 = RealMath_sin(z.re);
   cos0 = RealMath_cos(z.re);
   eb = RealMath_exp(z.im);
   emb = X2C_DIVR(1.0f,eb);
   x = cos0*(emb+eb);
   y = sin0*(emb-eb);
   x = x*x+y*y;
   return (tmp.re = X2C_DIVR(4.0f*sin0*cos0,x),
                tmp.im = X2C_DIVR((eb-emb)*(emb+eb),x),tmp);
} /* end tan() */


extern X2C_COMPLEX ComplexMath_arcsin(X2C_COMPLEX z)
{
   X2C_COMPLEX c;
   X2C_REAL rp;
   X2C_REAL phi;
   X2C_COMPLEX tmp;
   c = (tmp.re = (1.0f-z.re*z.re)+z.im*z.im,tmp.im = -(2.0f*z.re*z.im),tmp);
   if (CPLX_CMP(c,_cnst)==0) phi = 0.0f;
   else phi = X2C_DIVR(ComplexMath_arg(c),2.0f);
   rp = RealMath_sqrt(ComplexMath_abs(c));
   c = (tmp.re = -z.im+rp*RealMath_cos(phi),
                tmp.im = z.re+rp*RealMath_sin(phi),tmp);
   return (tmp.re = ComplexMath_arg(c),
                tmp.im = -RealMath_ln(ComplexMath_abs(c)),tmp);
} /* end arcsin() */


extern X2C_COMPLEX ComplexMath_arccos(X2C_COMPLEX z)
{
   X2C_COMPLEX c;
   X2C_REAL rp;
   X2C_REAL phi;
   X2C_COMPLEX tmp;
   c = (tmp.re = (1.0f-z.re*z.re)+z.im*z.im,tmp.im = -(2.0f*z.re*z.im),tmp);
   if (CPLX_CMP(c,_cnst)==0) phi = 0.0f;
   else phi = X2C_DIVR(ComplexMath_arg(c),2.0f);
   rp = RealMath_sqrt(ComplexMath_abs(c));
   c = (tmp.re = z.re-rp*RealMath_sin(phi),
                tmp.im = z.im+rp*RealMath_cos(phi),tmp);
   return (tmp.re = ComplexMath_arg(c),
                tmp.im = -RealMath_ln(ComplexMath_abs(c)),tmp);
} /* end arccos() */


extern X2C_COMPLEX ComplexMath_arctan(X2C_COMPLEX z)
{
   X2C_REAL den;
   X2C_REAL a2;
   X2C_REAL opb;
   X2C_COMPLEX c;
   X2C_COMPLEX tmp;
   opb = 1.0f+z.im;
   a2 = z.re*z.re;
   den = opb*opb+a2;
   c = (tmp.re = X2C_DIVR((1.0f-z.im)*opb-a2,den),
                tmp.im = X2C_DIVR(2.0f*z.re,den),tmp);
   return (tmp.re = X2C_DIVR(ComplexMath_arg(c),2.0f),
                tmp.im = -(X2C_DIVR(RealMath_ln(ComplexMath_abs(c)),2.0f)),
                tmp);
} /* end arctan() */


extern X2C_COMPLEX ComplexMath_polarToComplex(X2C_REAL abs0, X2C_REAL arg)
{
   X2C_COMPLEX tmp;
   return (tmp.re = abs0*RealMath_cos(arg),tmp.im = abs0*RealMath_sin(arg),
                tmp);
} /* end polarToComplex() */


extern X2C_COMPLEX ComplexMath_scalarMult(X2C_REAL scalar, X2C_COMPLEX z)
{
   X2C_COMPLEX tmp;
   return (tmp.re = z.re*scalar,tmp.im = z.im*scalar,tmp);
} /* end scalarMult() */


extern X2C_BOOLEAN ComplexMath_IsCMathException(void)
{
   return EXCEPTIONS_IsCurrentSource(source);
} /* end IsCMathException() */


extern void ComplexMath_BEGIN(void)
{
   static int ComplexMath_init = 0;
   if (ComplexMath_init) return;
   ComplexMath_init = 1;
   RealMath_BEGIN();
   EXCEPTIONS_BEGIN();
   EXCEPTIONS_AllocateSource(&source);
}

