/* XDS v2.51: Copyright (c) 1999-2003 Excelsior, LLC. All Rights Reserved. */
/* "@(#)FileName.c May 10 15:18:12 2005" */
/* Generated by XDS Modula-2 to ANSI C v4.20 translator */

#define X2C_int32
#define X2C_index32
#ifndef FileName_H_
#include "FileName.h"
#endif
#define FileName_C_
#ifndef platform_H_
#include "platform.h"
#endif
#ifndef xrFName_H_
#include "xrFName.h"
#endif
#ifndef Strings_H_
#include "Strings.h"
#endif




extern void FileName_GetFormat(X2C_CHAR s[], X2C_CARD32 s_len,
                struct FileName_Format * f)
{
   struct xrFName_Format f1;
   xrFName_X2C_ParseFileName(s, s_len, &f1);
   f->ok0 = f1.ok0;
   if (f->ok0) {
      f->dirPos = f1.dirPos;
      f->dirLen = f1.dirLen;
      f->namePos = f1.namePos;
      f->nameLen = f1.nameLen;
      f->extPos = f1.extPos;
      f->extLen = f1.extLen;
   }
} /* end GetFormat() */


extern void FileName_Get(X2C_CHAR fname[], X2C_CARD32 fname_len,
                X2C_CHAR dir[], X2C_CARD32 dir_len, X2C_CHAR name[],
                X2C_CARD32 name_len, X2C_CHAR ext[], X2C_CARD32 ext_len)
{
   X2C_PCOPY((void **)&fname,fname_len);
   xrFName_X2C_SplitFileName(fname, fname_len, dir, dir_len, name, name_len,
                ext, ext_len);
   X2C_PFREE(fname);
} /* end Get() */


extern void FileName_GetDir(X2C_CHAR fname[], X2C_CARD32 fname_len,
                X2C_CHAR dir[], X2C_CARD32 dir_len)
{
   X2C_PCOPY((void **)&fname,fname_len);
   xrFName_X2C_ExtractPath(fname, fname_len, dir, dir_len);
   X2C_PFREE(fname);
} /* end GetDir() */


extern void FileName_GetName(X2C_CHAR fname[], X2C_CARD32 fname_len,
                X2C_CHAR name[], X2C_CARD32 name_len)
{
   X2C_PCOPY((void **)&fname,fname_len);
   xrFName_X2C_ExtractBaseName(fname, fname_len, name, name_len);
   X2C_PFREE(fname);
} /* end GetName() */


extern void FileName_GetExt(X2C_CHAR fname[], X2C_CARD32 fname_len,
                X2C_CHAR ext[], X2C_CARD32 ext_len)
{
   X2C_PCOPY((void **)&fname,fname_len);
   xrFName_X2C_ExtractFileExt(fname, fname_len, ext, ext_len);
   X2C_PFREE(fname);
} /* end GetExt() */


extern X2C_CARD32 FileName_Length(X2C_CARD32 dir, X2C_CARD32 name,
                X2C_CARD32 ext)
{
   X2C_CARD32 len;
   len = dir;
   if (dir>0ul) {
      if (pl_vms) len += 2ul;
      else ++len;
   }
   if (pl_fatfs && name>8ul) len += 8ul;
   else len += name;
   if (pl_fatfs && ext>3ul) len += 3ul;
   else len += ext;
   if (ext>0ul) ++len;
   return len;
} /* end Length() */


static void append(X2C_CHAR d[], X2C_CARD32 d_len, X2C_CARD32 * p,
                X2C_CHAR s[], X2C_CARD32 s_len, X2C_CARD32 i,
                X2C_CARD32 len)
{
   while (*p<=d_len-1 && len>0ul) {
      d[*p] = s[i];
      ++*p;
      ++i;
      --len;
   }
} /* end append() */


static void char0(X2C_CHAR d[], X2C_CARD32 d_len, X2C_CARD32 * p,
                X2C_CHAR c)
{
   if (*p<=d_len-1) {
      d[*p] = c;
      ++*p;
   }
} /* end char() */


extern void FileName_Convert(X2C_CHAR str[], X2C_CARD32 str_len,
                X2C_CHAR fname[], X2C_CARD32 fname_len)
{
   struct FileName_Format f;
   X2C_CARD32 p;
   X2C_CHAR last;
   X2C_PCOPY((void **)&str,str_len);
   FileName_GetFormat(str, str_len, &f);
   if (f.ok0) {
      p = 0ul;
      if (f.dirLen>0ul && ((!pl_amiga || f.dirLen!=1ul)
                || str[f.dirPos]!='.')) {
         append(fname, fname_len, &p, str, str_len, f.dirPos, f.dirLen);
         last = str[(f.dirPos+f.dirLen)-1ul];
         if (pl_msdos || pl_amiga) {
            if (last!=pathEnd && last!=drvSep) {
               char0(fname, fname_len, &p, pathEnd);
            }
         }
         else if (!pl_vms && last!=pathEnd) {
            char0(fname, fname_len, &p, pathEnd);
         }
      }
      if (pl_fatfs && f.nameLen>8ul) f.nameLen = 8ul;
      append(fname, fname_len, &p, str, str_len, f.namePos, f.nameLen);
      if (f.extLen) {
         char0(fname, fname_len, &p, extSep);
         if (pl_fatfs && f.extLen>3ul) f.extLen = 3ul;
         append(fname, fname_len, &p, str, str_len, f.extPos, f.extLen);
      }
      if (p<=fname_len-1) fname[p] = 0;
      if (pl_msdos) Strings_Capitalize(fname, fname_len);
   }
   else fname[0ul] = 0;
   X2C_PFREE(str);
} /* end Convert() */


extern void FileName_ConvertExt(X2C_CHAR ext[], X2C_CARD32 ext_len)
{
   if (ext[0ul]=='.') Strings_Delete(ext, ext_len, 0ul, 1ul);
   if (pl_fatfs) {
      if (X2C_LENGTH(ext,ext_len)>3ul) ext[3ul] = 0x0u ;
      Strings_Capitalize(ext, ext_len);
   }
} /* end ConvertExt() */


extern void FileName_Create(X2C_CHAR dir[], X2C_CARD32 dir_len,
                X2C_CHAR name[], X2C_CARD32 name_len, X2C_CHAR ext[],
                X2C_CARD32 ext_len, X2C_CHAR fname[], X2C_CARD32 fname_len)
{
   X2C_CARD32 len;
   X2C_CARD32 p;
   X2C_CHAR last;
   X2C_PCOPY((void **)&dir,dir_len);
   X2C_PCOPY((void **)&name,name_len);
   X2C_PCOPY((void **)&ext,ext_len);
   p = 0ul;
   len = X2C_LENGTH(dir,dir_len);
   if (len>0ul && (!pl_amiga || X2C_STRCMP(dir,dir_len,".",2u))) {
      append(fname, fname_len, &p, dir, dir_len, 0ul, len);
      last = dir[len-1ul];
      if (pl_msdos || pl_amiga) {
         if (last!=pathEnd && last!=drvSep) {
            char0(fname, fname_len, &p, pathEnd);
         }
      }
      else if (!pl_vms && last!=pathEnd) {
         char0(fname, fname_len, &p, pathEnd);
      }
   }
   len = X2C_LENGTH(name,name_len);
   if (pl_fatfs && len>8ul) len = 8ul;
   append(fname, fname_len, &p, name, name_len, 0ul, len);
   if (ext[0ul]==extSep) Strings_Delete(ext, ext_len, 0ul, 1ul);
   len = X2C_LENGTH(ext,ext_len);
   if (len) {
      char0(fname, fname_len, &p, extSep);
      if (pl_fatfs && len>3ul) len = 3ul;
      append(fname, fname_len, &p, ext, ext_len, 0ul, len);
   }
   if (p<=fname_len-1) fname[p] = 0;
   if (pl_msdos) Strings_Capitalize(fname, fname_len);
   X2C_PFREE(dir);
   X2C_PFREE(name);
   X2C_PFREE(ext);
} /* end Create() */


extern void FileName_BEGIN(void)
{
   static int FileName_init = 0;
   if (FileName_init) return;
   FileName_init = 1;
   Strings_BEGIN();
   xrFName_BEGIN();
}

