/* XDS v2.51: Copyright (c) 1999-2003 Excelsior, LLC. All Rights Reserved. */
/* "@(#)FilePath.c May 10 15:18:09 2005" */
/* Generated by XDS Oberon-2 to ANSI C v4.20 translator */

#define X2C_int32
#define X2C_index32
#ifndef FilePath_H_
#include "FilePath.h"
#endif
#define FilePath_C_
#ifndef platform_H_
#include "platform.h"
#endif
#ifndef DStrings_H_
#include "DStrings.h"
#endif
#ifndef FileName_H_
#include "FileName.h"
#endif
#ifndef FileSys_H_
#include "FileSys.h"
#endif
#ifndef Strings_H_
#include "Strings.h"
#endif

extern struct X2C_MD_STR FilePath_desc;
static DStrings_String null;


extern X2C_BOOLEAN FilePath_IsSimpleName(X2C_CHAR name[],
                X2C_CARD32 name_len)
{
   struct FileName_Format f;
   FileName_GetFormat(name, name_len, &f);
   return f.ok0 && f.dirLen==0ul;
} /* end IsSimpleName() */


static void Parse(X2C_CHAR name[], X2C_CARD32 name_len,
                DStrings_String * dir, DStrings_String * ext)
{
   struct FileName_Format f;
   X2C_INDEX tmp[1];
   FileName_GetFormat(name, name_len, &f);
   if (f.dirLen==0ul) *dir = null;
   else {
      X2C_NEW_OPEN(x2c_td_null,(X2C_ADDRESS*)dir,1u,(tmp[0] = f.dirLen+1ul,
                tmp),1u,0);
   }
   if (f.extLen==0ul) *ext = null;
   else {
      X2C_NEW_OPEN(x2c_td_null,(X2C_ADDRESS*)ext,1u,(tmp[0] = f.extLen+1ul,
                tmp),1u,0);
   }
   FileName_Get(name, name_len, (*dir)->Adr, (*dir)->Len0, name, name_len,
                (*ext)->Adr, (*ext)->Len0);
} /* end Parse() */


static void Create0(DStrings_String dir, DStrings_String ext,
                X2C_CHAR name[], X2C_CARD32 name_len,
                DStrings_String * fname)
{
   X2C_INT32 len;
   X2C_INDEX tmp[1];
   if (X2C_STRCMP(dir->Adr,dir->Len0,".",2u)==0) dir->Adr[0ul] = 0x0u ;
   len = (X2C_INT32)FileName_Length((X2C_CARD32)X2C_LENGTH(dir->Adr,
                dir->Len0), (X2C_CARD32)X2C_LENGTH(name,name_len),
                (X2C_CARD32)X2C_LENGTH(ext->Adr,ext->Len0));
   if (len>=(*fname)->Len0) {
      X2C_NEW_OPEN(x2c_td_null,(X2C_ADDRESS*)fname,1u,
                (tmp[0] = (size_t)(len+1l),tmp),1u,0);
   }
   FileName_Create(dir->Adr, dir->Len0, name, name_len, ext->Adr, ext->Len0,
                (*fname)->Adr, (*fname)->Len0);
} /* end Create() */


extern void FilePath_Lookup(X2C_CHAR path[], X2C_CARD32 path_len,
                X2C_CHAR name[], X2C_CARD32 name_len,
                DStrings_String * fname, X2C_INT16 * n)
{
   DStrings_String ext = 0;
   DStrings_String dir = 0;
   X2C_INT16 flen;
   X2C_INT16 fpos;
   X2C_INT16 i;
   X2C_INT16 p;
   X2C_INT32 len;
   X2C_INT16 dir_no;
   X2C_INDEX tmp[1];
   X2C_PCOPY((void **)&name,name_len);
   *fname = null;
   Parse(name, name_len, &dir, &ext);
   if (dir==null) {
      *n = 0;
      dir_no = 1;
      i = 0;
      len = X2C_LENGTH(path,path_len);
      flen = 0;
      fpos = 32767;
      for (;;) {
         while ((X2C_INT32)i<len && IsPathDelim(path[i])) ++i;
         if ((X2C_INT32)i==len) break;
         p = i;
         if (fpos>i) fpos = i;
         while ((X2C_INT32)i<len && !IsPathDelim(path[i])) ++i;
         if (flen==0) flen = i-fpos;
         if ((X2C_INT32)(i-p)>=dir->Len0) {
            X2C_NEW_OPEN(x2c_td_null,(X2C_ADDRESS*) &dir,1u,
                (tmp[0] = (size_t)((i-p)+1),tmp),1u,0);
         }
         Strings_Extract(path, path_len, (X2C_CARD32)p, (X2C_CARD32)(i-p),
                dir->Adr, dir->Len0);
         Create0(dir, ext, name, name_len, fname);
         if (FileSys_Exists((*fname)->Adr, (*fname)->Len0)) {
            *n = dir_no;
            goto label;
         }
         ++dir_no;
      }
      if (flen>0) {
         Strings_Extract(path, path_len, (X2C_CARD32)fpos, (X2C_CARD32)flen,
                dir->Adr, dir->Len0);
      }
      else dir->Adr[0ul] = 0x0u ;
   }
   else *n = -1;
   Create0(dir, ext, name, name_len, fname);
   label:;
   X2C_PFREE(name);
} /* end Lookup() */


extern void FilePath_UseFirst(X2C_CHAR path[], X2C_CARD32 path_len,
                X2C_CHAR name[], X2C_CARD32 name_len,
                DStrings_String * fname)
{
   DStrings_String ext = 0;
   DStrings_String dir = 0;
   X2C_INT16 i;
   X2C_INT16 p;
   X2C_INT32 len;
   X2C_INDEX tmp[1];
   X2C_PCOPY((void **)&name,name_len);
   *fname = null;
   Parse(name, name_len, &dir, &ext);
   if (dir==null) {
      i = 0;
      len = X2C_LENGTH(path,path_len);
      while ((X2C_INT32)i<len && IsPathDelim(path[i])) ++i;
      if ((X2C_INT32)i<len) {
         p = i;
         while ((X2C_INT32)i<len && !IsPathDelim(path[i])) ++i;
         if ((X2C_INT32)(i-p)>=dir->Len0) {
            X2C_NEW_OPEN(x2c_td_null,(X2C_ADDRESS*) &dir,1u,
                (tmp[0] = (size_t)((i-p)+1),tmp),1u,0);
         }
         Strings_Extract(path, path_len, (X2C_CARD32)p, (X2C_CARD32)(i-p),
                dir->Adr, dir->Len0);
      }
   }
   Create0(dir, ext, name, name_len, fname);
   X2C_PFREE(name);
} /* end UseFirst() */


static void * FilePath_offs[] = {
   &null,
   X2C_OFS_END
};
static X2C_PROC FilePath_cmds[] = { 0 };
static X2C_CHAR * FilePath_cnms[] = { 0 };
struct X2C_MD_STR FilePath_desc = {
  0, 0, "FilePath",FilePath_offs,FilePath_cmds,FilePath_cnms,0
};

extern void FilePath_BEGIN(void)
{
   X2C_INDEX tmp[1];
   static int FilePath_init = 0;
   if (FilePath_init) return;
   FilePath_init = 1;
   Strings_BEGIN();
   FileSys_BEGIN();
   FileName_BEGIN();
   DStrings_BEGIN();
   X2C_MODULE(&FilePath_desc);
   X2C_NEW_OPEN(x2c_td_null,(X2C_ADDRESS*) &null,1u,(tmp[0] = 1u,tmp),1u,0);
   null->Adr[0ul] = 0x0u ;
}

