/* XDS v2.51: Copyright (c) 1999-2003 Excelsior, LLC. All Rights Reserved. */
/* "@(#)MathC.c May 10 15:18:09 2005" */
/* Generated by XDS Oberon-2 to ANSI C v4.20 translator */

#define X2C_int32
#define X2C_index32
#ifndef MathC_H_
#include "MathC.h"
#endif
#define MathC_C_
#ifndef EXCEPTIONS_H_
#include "EXCEPTIONS.h"
#endif
#ifndef Strings_H_
#include "Strings.h"
#endif
#ifndef MathR_H_
#include "MathR.h"
#endif

extern struct X2C_MD_STR MathC_desc;
static EXCEPTIONS_ExceptionSource source;

static X2C_LONGCOMPLEX MathC_i = {0.0,1.0};

static X2C_LONGCOMPLEX MathC_zero = {0.0,0.0};


static void raise0(X2C_INT16 n, X2C_CHAR s[], X2C_CARD32 s_len)
{
   X2C_CHAR m[80];
   Strings_Concat("MathC.", 7ul, s, s_len, m, 80ul);
   EXCEPTIONS_RAISE(source, (X2C_CARD32)n, m, 80ul);
} /* end raise() */


extern X2C_REAL MathC_abs(X2C_COMPLEX z)
{
   return MathR_sqrt(z.re*z.re+z.im*z.im);
} /* end abs() */

static X2C_COMPLEX _cnst1 = {0.0,0.0};

static X2C_REAL arg(X2C_COMPLEX z)
{
   if (CPLX_CMP(z,_cnst1)==0) return 0.0f;
   else return MathR_arctan2(z.re, z.im);
   return 0;
} /* end arg() */


extern X2C_COMPLEX MathC_conj(X2C_COMPLEX z)
{
   X2C_COMPLEX tmp;
   return (tmp.re = z.re,tmp.im = -z.im,tmp);
} /* end conj() */


extern X2C_COMPLEX MathC_power(X2C_COMPLEX base, X2C_REAL exponent)
{
   X2C_REAL y;
   X2C_REAL x;
   X2C_COMPLEX tmp;
   if (CPLX_CMP(base,_cnst1)==0 && exponent>0.0f) return _cnst1;
   x = MathR_power(MathC_abs(base), exponent);
   y = exponent*arg(base);
   return (tmp.re = x*MathR_cos(y),tmp.im = x*MathR_sin(y),tmp);
} /* end power() */


extern X2C_COMPLEX MathC_sqrt(X2C_COMPLEX z)
{
   X2C_REAL y;
   X2C_REAL x;
   X2C_COMPLEX tmp;
   x = MathR_sqrt(MathC_abs(z));
   y = X2C_DIVR(arg(z),2.0f);
   return (tmp.re = x*MathR_cos(y),tmp.im = x*MathR_sin(y),tmp);
} /* end sqrt() */


extern X2C_COMPLEX MathC_exp(X2C_COMPLEX z)
{
   X2C_REAL x;
   X2C_COMPLEX tmp;
   x = MathR_exp(z.re);
   return (tmp.re = x*MathR_cos(z.im),tmp.im = x*MathR_sin(z.im),tmp);
} /* end exp() */


extern X2C_COMPLEX MathC_ln(X2C_COMPLEX z)
{
   X2C_COMPLEX tmp;
   return (tmp.re = MathR_ln(MathC_abs(z)),tmp.im = arg(z),tmp);
} /* end ln() */


extern X2C_COMPLEX MathC_log(X2C_COMPLEX z, X2C_REAL base)
{
   X2C_REAL x;
   X2C_COMPLEX tmp;
   if (base<=0.0f) raise0(0, "log: negative or zero base", 27ul);
   x = MathR_ln(base);
   return (tmp.re = X2C_DIVR(MathR_ln(MathC_abs(z)),x),
                tmp.im = X2C_DIVR(arg(z),x),tmp);
} /* end log() */


extern X2C_COMPLEX MathC_sin(X2C_COMPLEX z)
{
   X2C_LONGREAL y;
   X2C_LONGREAL x;
   X2C_COMPLEX tmp;
   x = (X2C_LONGREAL)MathR_exp(z.im);
   y = X2C_DIVL(1.0,x);
   return (tmp.re = (X2C_REAL)(X2C_DIVL((X2C_LONGREAL)MathR_sin(z.re)*(y+x),
                2.0)),tmp.im = (X2C_REAL) -((X2C_LONGREAL)(0.5f*MathR_cos(z.re))*(y-x)),
                tmp);
} /* end sin() */


extern X2C_COMPLEX MathC_cos(X2C_COMPLEX z)
{
   X2C_LONGREAL y;
   X2C_LONGREAL x;
   X2C_COMPLEX tmp;
   x = (X2C_LONGREAL)MathR_exp(z.im);
   y = X2C_DIVL(1.0,x);
   return (tmp.re = (X2C_REAL)(X2C_DIVL((X2C_LONGREAL)MathR_cos(z.re)*(y+x),
                2.0)),tmp.im = (X2C_REAL)(X2C_DIVL((X2C_LONGREAL)MathR_sin(z.re)*(y-x),
                2.0)),tmp);
} /* end cos() */


extern X2C_COMPLEX MathC_tan(X2C_COMPLEX z)
{
   X2C_REAL b;
   X2C_REAL a;
   X2C_REAL cos0;
   X2C_REAL sin0;
   X2C_LONGREAL y;
   X2C_LONGREAL x;
   X2C_COMPLEX tmp;
   if (CPLX_CMP(z,_cnst1)==0) return _cnst1;
   sin0 = MathR_sin(z.re);
   cos0 = MathR_cos(z.re);
   x = (X2C_LONGREAL)MathR_exp(z.im);
   y = X2C_DIVL(1.0,x);
   a = cos0*(X2C_REAL)(x+y);
   b = sin0*(X2C_REAL)(x-y);
   a = a*a+b*b;
   return (tmp.re = X2C_DIVR(4.0f*sin0*cos0,a),
                tmp.im = X2C_DIVR((X2C_REAL)((x-y)*(x+y)),a),tmp);
} /* end tan() */


extern X2C_COMPLEX MathC_arcsin(X2C_COMPLEX z)
{
   X2C_COMPLEX c;
   X2C_REAL rp;
   X2C_REAL phi;
   X2C_COMPLEX tmp;
   if ((X2C_REAL)fabs(z.re)>1.0f) {
      raise0(1, "arcsin: RE(argument) is not in range -1.0..1.0", 47ul);
   }
   c = (tmp.re = (1.0f-z.re*z.re)+z.im*z.im,tmp.im = -(2.0f*z.re*z.im),tmp);
   phi = X2C_DIVR(arg(c),2.0f);
   rp = MathR_sqrt(MathC_abs(c));
   c = (tmp.re = -z.im+rp*MathR_cos(phi),tmp.im = z.re+rp*MathR_sin(phi),
                tmp);
   return (tmp.re = arg(c),tmp.im = -MathR_ln(MathC_abs(c)),tmp);
} /* end arcsin() */


extern X2C_COMPLEX MathC_arccos(X2C_COMPLEX z)
{
   X2C_COMPLEX c;
   X2C_REAL rp;
   X2C_REAL phi;
   X2C_COMPLEX tmp;
   if ((X2C_REAL)fabs(z.re)>1.0f) {
      raise0(2, "arccos: RE(argument) is not in range -1.0..1.0", 47ul);
   }
   c = (tmp.re = (1.0f-z.re*z.re)+z.im*z.im,tmp.im = -(2.0f*z.re*z.im),tmp);
   phi = X2C_DIVR(arg(c),2.0f);
   rp = MathR_sqrt(MathC_abs(c));
   c = (tmp.re = z.re-rp*MathR_sin(phi),tmp.im = z.im+rp*MathR_cos(phi),tmp);
   return (tmp.re = arg(c),tmp.im = -MathR_ln(MathC_abs(c)),tmp);
} /* end arccos() */


extern X2C_COMPLEX MathC_arctan(X2C_COMPLEX z)
{
   X2C_REAL den;
   X2C_REAL a2;
   X2C_REAL opb;
   X2C_COMPLEX c;
   X2C_COMPLEX tmp;
   opb = 1.0f+z.im;
   a2 = z.re*z.re;
   den = opb*opb+a2;
   c = (tmp.re = X2C_DIVR((1.0f-z.im)*opb-a2,den),
                tmp.im = X2C_DIVR(2.0f*z.re,den),tmp);
   return (tmp.re = 0.5f*arg(c),tmp.im = -(0.5f*MathR_ln(MathC_abs(c))),tmp);
                
} /* end arctan() */

static X2C_COMPLEX _cnst = {0.0,1.0};

extern X2C_COMPLEX MathC_arctan2(X2C_COMPLEX zn, X2C_COMPLEX zd)
{
   X2C_COMPLEX c;
   X2C_COMPLEX tmp;
   if (CPLX_CMP(zn,_cnst1)==0 && CPLX_CMP(zd,_cnst1)==0) {
      raise0(3, "arctan2: zero arguments", 24ul);
   }
   c = CPLX_DIV(CPLX_ADD(zd,CPLX_MUL(_cnst,zn)),CPLX_SUB(zd,CPLX_MUL(_cnst,
                zn)));
   return (tmp.re = 0.5f*arg(c),tmp.im = -(0.5f*MathR_ln(MathC_abs(c))),tmp);
                
} /* end arctan2() */


extern X2C_COMPLEX MathC_sinh(X2C_COMPLEX z)
{
   X2C_LONGREAL y;
   X2C_LONGREAL x;
   X2C_COMPLEX tmp;
   x = (X2C_LONGREAL)MathR_exp(z.re);
   y = X2C_DIVL(1.0,x);
   return (tmp.re = (X2C_REAL)(X2C_DIVL((X2C_LONGREAL)MathR_cos(z.im)*(x-y),
                2.0)),tmp.im = (X2C_REAL)(X2C_DIVL((X2C_LONGREAL)MathR_sin(z.im)*(x+y),
                2.0)),tmp);
} /* end sinh() */


extern X2C_COMPLEX MathC_cosh(X2C_COMPLEX z)
{
   X2C_LONGREAL y;
   X2C_LONGREAL x;
   X2C_COMPLEX tmp;
   x = (X2C_LONGREAL)MathR_exp(z.re);
   y = X2C_DIVL(1.0,x);
   return (tmp.re = (X2C_REAL)(X2C_DIVL((X2C_LONGREAL)MathR_cos(z.im)*(x+y),
                2.0)),tmp.im = (X2C_REAL)(X2C_DIVL((X2C_LONGREAL)MathR_sin(z.im)*(x-y),
                2.0)),tmp);
} /* end cosh() */


extern X2C_COMPLEX MathC_tanh(X2C_COMPLEX z)
{
   X2C_LONGREAL y;
   X2C_LONGREAL x;
   X2C_REAL div0;
   X2C_REAL plus;
   X2C_REAL minus;
   X2C_REAL cos0;
   X2C_REAL sin0;
   X2C_COMPLEX tmp;
   x = (X2C_LONGREAL)MathR_exp(z.re);
   y = X2C_DIVL(1.0,x);
   minus = (X2C_REAL)(x-y);
   plus = (X2C_REAL)(x+y);
   sin0 = MathR_sin(z.im);
   cos0 = MathR_cos(z.im);
   div0 = X2C_EXPRI(cos0*plus,2l)+X2C_EXPRI(sin0*minus,2l);
   return (tmp.re = X2C_DIVR(minus*plus,div0),
                tmp.im = X2C_DIVR(4.0f*sin0*cos0,div0),tmp);
} /* end tanh() */

static X2C_COMPLEX _cnst0 = {0.0,-1.0};

extern X2C_COMPLEX MathC_arcsinh(X2C_COMPLEX z)
{
   X2C_COMPLEX tmp;
   return CPLX_MUL(MathC_arcsin((tmp.re = -z.im,tmp.im = z.re,tmp)),_cnst0);
} /* end arcsinh() */


extern X2C_COMPLEX MathC_arccosh(X2C_COMPLEX z)
{
   return CPLX_MUL(_cnst,MathC_arccos(z));
} /* end arccosh() */


extern X2C_COMPLEX MathC_arctanh(X2C_COMPLEX z)
{
   X2C_COMPLEX tmp;
   return CPLX_MUL(MathC_arctan((tmp.re = -z.im,tmp.im = z.re,tmp)),_cnst0);
} /* end arctanh() */


static void * MathC_offs[] = {
   X2C_OFS_END
};
static X2C_PROC MathC_cmds[] = { 0 };
static X2C_CHAR * MathC_cnms[] = { 0 };
struct X2C_MD_STR MathC_desc = {
  0, 0, "MathC",MathC_offs,MathC_cmds,MathC_cnms,0
};

extern void MathC_BEGIN(void)
{
   static int MathC_init = 0;
   if (MathC_init) return;
   MathC_init = 1;
   MathR_BEGIN();
   Strings_BEGIN();
   EXCEPTIONS_BEGIN();
   X2C_MODULE(&MathC_desc);
   EXCEPTIONS_AllocateSource(&source);
}

