/* XDS v2.51: Copyright (c) 1999-2003 Excelsior, LLC. All Rights Reserved. */
/* "@(#)MathCL.c May 10 15:18:09 2005" */
/* Generated by XDS Oberon-2 to ANSI C v4.20 translator */

#define X2C_int32
#define X2C_index32
#ifndef MathCL_H_
#include "MathCL.h"
#endif
#define MathCL_C_
#ifndef EXCEPTIONS_H_
#include "EXCEPTIONS.h"
#endif
#ifndef Strings_H_
#include "Strings.h"
#endif
#ifndef MathL_H_
#include "MathL.h"
#endif

extern struct X2C_MD_STR MathCL_desc;
static EXCEPTIONS_ExceptionSource source;

static X2C_LONGCOMPLEX MathCL_i = {0.0,1.0};

static X2C_LONGCOMPLEX MathCL_zero = {0.0,0.0};


static void raise0(X2C_INT16 n, X2C_CHAR s[], X2C_CARD32 s_len)
{
   X2C_CHAR m[80];
   Strings_Concat("MathCL.", 8ul, s, s_len, m, 80ul);
   EXCEPTIONS_RAISE(source, (X2C_CARD32)n, m, 80ul);
} /* end raise() */


extern X2C_LONGREAL MathCL_abs(X2C_LONGCOMPLEX z)
{
   return MathL_sqrt(z.re*z.re+z.im*z.im);
} /* end abs() */

static X2C_LONGCOMPLEX _cnst1 = {0.0,0.0};

static X2C_LONGREAL arg(X2C_LONGCOMPLEX z)
{
   if (CPLX_LCMP(z,_cnst1)==0) return 0.0;
   else return MathL_arctan2(z.re, z.im);
   return 0;
} /* end arg() */


extern X2C_LONGCOMPLEX MathCL_conj(X2C_LONGCOMPLEX z)
{
   X2C_LONGCOMPLEX tmp;
   return (tmp.re = z.re,tmp.im = -z.im,tmp);
} /* end conj() */


extern X2C_LONGCOMPLEX MathCL_power(X2C_LONGCOMPLEX base,
                X2C_LONGREAL exponent)
{
   X2C_LONGREAL y;
   X2C_LONGREAL x;
   X2C_LONGCOMPLEX tmp;
   if (CPLX_LCMP(base,_cnst1)==0 && exponent>0.0) return _cnst1;
   x = MathL_power(MathCL_abs(base), exponent);
   y = exponent*arg(base);
   return (tmp.re = x*MathL_cos(y),tmp.im = x*MathL_sin(y),tmp);
} /* end power() */


extern X2C_LONGCOMPLEX MathCL_sqrt(X2C_LONGCOMPLEX z)
{
   X2C_LONGREAL y;
   X2C_LONGREAL x;
   X2C_LONGCOMPLEX tmp;
   x = MathL_sqrt(MathCL_abs(z));
   y = X2C_DIVL(arg(z),2.0);
   return (tmp.re = x*MathL_cos(y),tmp.im = x*MathL_sin(y),tmp);
} /* end sqrt() */


extern X2C_LONGCOMPLEX MathCL_exp(X2C_LONGCOMPLEX z)
{
   X2C_LONGREAL x;
   X2C_LONGCOMPLEX tmp;
   x = MathL_exp(z.re);
   return (tmp.re = x*MathL_cos(z.im),tmp.im = x*MathL_sin(z.im),tmp);
} /* end exp() */


extern X2C_LONGCOMPLEX MathCL_ln(X2C_LONGCOMPLEX z)
{
   X2C_LONGCOMPLEX tmp;
   return (tmp.re = MathL_ln(MathCL_abs(z)),tmp.im = arg(z),tmp);
} /* end ln() */


extern X2C_LONGCOMPLEX MathCL_log(X2C_LONGCOMPLEX z, X2C_LONGREAL base)
{
   X2C_LONGREAL x;
   X2C_LONGCOMPLEX tmp;
   if (base<=0.0) raise0(0, "log: negative or zero base", 27ul);
   x = MathL_ln(base);
   return (tmp.re = X2C_DIVL(MathL_ln(MathCL_abs(z)),x),
                tmp.im = X2C_DIVL(arg(z),x),tmp);
} /* end log() */


extern X2C_LONGCOMPLEX MathCL_sin(X2C_LONGCOMPLEX z)
{
   X2C_LONGREAL y;
   X2C_LONGREAL x;
   X2C_LONGCOMPLEX tmp;
   x = MathL_exp(z.im);
   y = X2C_DIVL(1.0,x);
   return (tmp.re = X2C_DIVL(MathL_sin(z.re)*(y+x),2.0),
                tmp.im = -(0.5*MathL_cos(z.re)*(y-x)),tmp);
} /* end sin() */


extern X2C_LONGCOMPLEX MathCL_cos(X2C_LONGCOMPLEX z)
{
   X2C_LONGREAL y;
   X2C_LONGREAL x;
   X2C_LONGCOMPLEX tmp;
   x = MathL_exp(z.im);
   y = X2C_DIVL(1.0,x);
   return (tmp.re = X2C_DIVL(MathL_cos(z.re)*(y+x),2.0),
                tmp.im = X2C_DIVL(MathL_sin(z.re)*(y-x),2.0),tmp);
} /* end cos() */


extern X2C_LONGCOMPLEX MathCL_tan(X2C_LONGCOMPLEX z)
{
   X2C_LONGREAL b;
   X2C_LONGREAL a;
   X2C_LONGREAL cos0;
   X2C_LONGREAL sin0;
   X2C_LONGREAL y;
   X2C_LONGREAL x;
   X2C_LONGCOMPLEX tmp;
   if (CPLX_LCMP(z,_cnst1)==0) return _cnst1;
   sin0 = MathL_sin(z.re);
   cos0 = MathL_cos(z.re);
   x = MathL_exp(z.im);
   y = X2C_DIVL(1.0,x);
   a = cos0*(x+y);
   b = sin0*(x-y);
   a = a*a+b*b;
   return (tmp.re = X2C_DIVL(4.0*sin0*cos0,a),tmp.im = X2C_DIVL((x-y)*(x+y),
                a),tmp);
} /* end tan() */


extern X2C_LONGCOMPLEX MathCL_arcsin(X2C_LONGCOMPLEX z)
{
   X2C_LONGCOMPLEX c;
   X2C_LONGREAL rp;
   X2C_LONGREAL phi;
   X2C_LONGCOMPLEX tmp;
   c = (tmp.re = (1.0-z.re*z.re)+z.im*z.im,tmp.im = -(2.0*z.re*z.im),tmp);
   phi = X2C_DIVL(arg(c),2.0);
   rp = MathL_sqrt(MathCL_abs(c));
   c = (tmp.re = -z.im+rp*MathL_cos(phi),tmp.im = z.re+rp*MathL_sin(phi),
                tmp);
   return (tmp.re = arg(c),tmp.im = -MathL_ln(MathCL_abs(c)),tmp);
} /* end arcsin() */


extern X2C_LONGCOMPLEX MathCL_arccos(X2C_LONGCOMPLEX z)
{
   X2C_LONGCOMPLEX c;
   X2C_LONGREAL rp;
   X2C_LONGREAL phi;
   X2C_LONGCOMPLEX tmp;
   c = (tmp.re = (1.0-z.re*z.re)+z.im*z.im,tmp.im = -(2.0*z.re*z.im),tmp);
   phi = X2C_DIVL(arg(c),2.0);
   rp = MathL_sqrt(MathCL_abs(c));
   c = (tmp.re = z.re-rp*MathL_sin(phi),tmp.im = z.im+rp*MathL_cos(phi),tmp);
   return (tmp.re = arg(c),tmp.im = -MathL_ln(MathCL_abs(c)),tmp);
} /* end arccos() */


extern X2C_LONGCOMPLEX MathCL_arctan(X2C_LONGCOMPLEX z)
{
   X2C_LONGREAL den;
   X2C_LONGREAL a2;
   X2C_LONGREAL opb;
   X2C_LONGCOMPLEX c;
   X2C_LONGCOMPLEX tmp;
   opb = 1.0+z.im;
   a2 = z.re*z.re;
   den = opb*opb+a2;
   c = (tmp.re = X2C_DIVL((1.0-z.im)*opb-a2,den),tmp.im = X2C_DIVL(2.0*z.re,
                den),tmp);
   return (tmp.re = X2C_DIVL(arg(c),2.0),
                tmp.im = -(X2C_DIVL(MathL_ln(MathCL_abs(c)),2.0)),tmp);
} /* end arctan() */

static X2C_LONGCOMPLEX _cnst = {0.0,1.0};

extern X2C_LONGCOMPLEX MathCL_arctan2(X2C_LONGCOMPLEX zn,
                X2C_LONGCOMPLEX zd)
{
   X2C_LONGCOMPLEX c;
   X2C_LONGCOMPLEX tmp;
   c = CPLX_LDIV(CPLX_LADD(zd,CPLX_LMUL(_cnst,zn)),CPLX_LSUB(zd,
                CPLX_LMUL(_cnst,zn)));
   return (tmp.re = 0.5*arg(c),tmp.im = -(0.5*MathL_ln(MathCL_abs(c))),tmp);
} /* end arctan2() */


extern X2C_LONGCOMPLEX MathCL_sinh(X2C_LONGCOMPLEX z)
{
   X2C_LONGREAL y;
   X2C_LONGREAL x;
   X2C_LONGCOMPLEX tmp;
   x = MathL_exp(z.re);
   y = X2C_DIVL(1.0,x);
   return (tmp.re = X2C_DIVL(MathL_cos(z.im)*(x-y),2.0),
                tmp.im = X2C_DIVL(MathL_sin(z.im)*(x+y),2.0),tmp);
} /* end sinh() */


extern X2C_LONGCOMPLEX MathCL_cosh(X2C_LONGCOMPLEX z)
{
   X2C_LONGREAL y;
   X2C_LONGREAL x;
   X2C_LONGCOMPLEX tmp;
   x = MathL_exp(z.re);
   y = X2C_DIVL(1.0,x);
   return (tmp.re = X2C_DIVL(MathL_cos(z.im)*(x+y),2.0),
                tmp.im = X2C_DIVL(MathL_sin(z.im)*(x-y),2.0),tmp);
} /* end cosh() */


extern X2C_LONGCOMPLEX MathCL_tanh(X2C_LONGCOMPLEX z)
{
   X2C_LONGREAL y;
   X2C_LONGREAL x;
   X2C_LONGREAL div0;
   X2C_LONGREAL plus;
   X2C_LONGREAL minus;
   X2C_LONGREAL cos0;
   X2C_LONGREAL sin0;
   X2C_LONGCOMPLEX tmp;
   x = MathL_exp(z.re);
   y = X2C_DIVL(1.0,x);
   minus = x-y;
   plus = x+y;
   sin0 = MathL_sin(z.im);
   cos0 = MathL_cos(z.im);
   div0 = X2C_EXPRI(cos0*plus,2l)+X2C_EXPRI(sin0*minus,2l);
   return (tmp.re = X2C_DIVL(minus*plus,div0),
                tmp.im = X2C_DIVL(4.0*sin0*cos0,div0),tmp);
} /* end tanh() */

static X2C_LONGCOMPLEX _cnst0 = {0.0,-1.0};

extern X2C_LONGCOMPLEX MathCL_arcsinh(X2C_LONGCOMPLEX z)
{
   X2C_LONGCOMPLEX tmp;
   return CPLX_LMUL(MathCL_arcsin((tmp.re = -z.im,tmp.im = z.re,tmp)),
                _cnst0);
} /* end arcsinh() */


extern X2C_LONGCOMPLEX MathCL_arccosh(X2C_LONGCOMPLEX z)
{
   return CPLX_LMUL(_cnst,MathCL_arccos(z));
} /* end arccosh() */


extern X2C_LONGCOMPLEX MathCL_arctanh(X2C_LONGCOMPLEX z)
{
   X2C_LONGCOMPLEX tmp;
   return CPLX_LMUL(MathCL_arctan((tmp.re = -z.im,tmp.im = z.re,tmp)),
                _cnst0);
} /* end arctanh() */


static void * MathCL_offs[] = {
   X2C_OFS_END
};
static X2C_PROC MathCL_cmds[] = { 0 };
static X2C_CHAR * MathCL_cnms[] = { 0 };
struct X2C_MD_STR MathCL_desc = {
  0, 0, "MathCL",MathCL_offs,MathCL_cmds,MathCL_cnms,0
};

extern void MathCL_BEGIN(void)
{
   static int MathCL_init = 0;
   if (MathCL_init) return;
   MathCL_init = 1;
   MathL_BEGIN();
   Strings_BEGIN();
   EXCEPTIONS_BEGIN();
   X2C_MODULE(&MathCL_desc);
   EXCEPTIONS_AllocateSource(&source);
}

