/* XDS v2.51: Copyright (c) 1999-2003 Excelsior, LLC. All Rights Reserved. */
/* "@(#)TimeConv.c May 10 15:18:12 2005" */
/* Generated by XDS Modula-2 to ANSI C v4.20 translator */

#define X2C_int32
#define X2C_index32
#ifndef TimeConv_H_
#include "TimeConv.h"
#endif
#define TimeConv_C_
#ifndef SysClock_H_
#include "SysClock.h"
#endif

#define TimeConv_y001days 365

#define TimeConv_y004days 1461

#define TimeConv_y100days 36524

#define TimeConv_y400days 146097

static X2C_CARD32 TimeConv_monthAdd[12] = {0ul,3ul,3ul,6ul,8ul,11ul,13ul,
                16ul,19ul,21ul,24ul,26ul};

static X2C_CARD32 TimeConv_monthLast[12] = {31ul,59ul,90ul,120ul,151ul,181ul,
                212ul,243ul,273ul,304ul,334ul,365ul};

static X2C_CARD32 FirstValidYear;


static X2C_BOOLEAN is_leap(X2C_CARD32 y)
{
   return (y&3ul)==0ul && y%100ul || y%400ul==0ul;
} /* end is_leap() */

static X2C_CARD32 _cnst[12] = {0ul,3ul,3ul,6ul,8ul,11ul,13ul,16ul,19ul,21ul,
                24ul,26ul};

static X2C_CARD32 day_of_year(X2C_CARD32 y, X2C_CARD32 m, X2C_CARD32 d)
{
   X2C_CARD32 x;
   --m;
   x = d+m*28ul+_cnst[m];
   if (m>=2ul && is_leap(y)) ++x;
   return x;
} /* end day_of_year() */


static X2C_CARD32 the_day(X2C_CARD32 y, X2C_CARD32 m, X2C_CARD32 d)
{
   X2C_CARD32 year;
   X2C_CARD32 day;
   year = y;
   y -= FirstValidYear;
   day = (y/400ul)*146097ul;
   y = y%400ul;
   day += (y/100ul)*36524ul;
   y = y%100ul;
   day += (y/4ul)*1461ul;
   day += (y&3ul)*365ul;
   day += day_of_year(year, m, d);
   return day;
} /* end the_day() */


static X2C_CARD32 sub_days(struct SysClock_DateTime g,
                struct SysClock_DateTime l)
{
   X2C_CARD32 c;
   c = ((l.year-FirstValidYear)/400ul)*400ul;
   g.year = g.year-c;
   l.year = l.year-c;
   return the_day(g.year, g.month, g.day)-the_day(l.year, l.month, l.day);
} /* end sub_days() */


static X2C_CARD32 day_sec(X2C_CARD32 h, X2C_CARD32 m, X2C_CARD32 s)
{
   return s+m*60ul+h*3600ul;
} /* end day_sec() */


static X2C_CARD32 sub_secs(struct SysClock_DateTime g,
                struct SysClock_DateTime l)
{
   X2C_CARD32 days;
   days = sub_days(g, l);
   return (days*86400ul+day_sec(g.hour, g.minute, g.second))-day_sec(l.hour,
                l.minute, l.second);
} /* end sub_secs() */

static X2C_CARD32 _cnst0[12] = {31ul,59ul,90ul,120ul,151ul,181ul,212ul,243ul,
                273ul,304ul,334ul,365ul};

static void unpack_day(X2C_CARD32 day, X2C_CARD32 * y, X2C_CARD32 * m,
                X2C_CARD32 * d)
{
   X2C_CARD32 i;
   X2C_BOOLEAN leap;
   --day;
   *y = 400ul*(day/146097ul);
   day = day%146097ul;
   i = day/36524ul;
   if (i==4ul) i = 3ul;
   *y += i*100ul;
   day -= i*36524ul;
   i = day/1461ul;
   day -= i*1461ul;
   *y += i*4ul;
   i = day/365ul;
   if (i==4ul) i = 3ul;
   *y += i;
   day -= i*365ul;
   leap = is_leap(*y+FirstValidYear);
   ++day;
   *m = day/32ul;
   day -= (X2C_CARD32)(leap && day>31ul);
   while (*m<=11ul && day>_cnst0[*m]) ++*m;
   *d = day;
   if (*m>0ul) *d -= _cnst0[*m-1ul];
   ++*m;
   *d += (X2C_CARD32)(leap && *m==2ul);
} /* end unpack_day() */


static void add_days(X2C_CARD32 * y, X2C_CARD32 * m, X2C_CARD32 * d,
                X2C_CARD32 days)
{
   X2C_CARD32 cy400s;
   cy400s = (*y-FirstValidYear)/400ul;
   *y -= cy400s*400ul;
   cy400s += days/146097ul;
   days = days%146097ul;
   unpack_day(days+the_day(*y, *m, *d), y, m, d);
   *y = *y+cy400s*400ul+FirstValidYear;
} /* end add_days() */


static void add_secs(X2C_CARD32 * y, X2C_CARD32 * m, X2C_CARD32 * d,
                X2C_CARD32 * h, X2C_CARD32 * mi, X2C_CARD32 * s,
                X2C_CARD32 secs)
{
   X2C_CARD32 days;
   secs += day_sec(*h, *mi, *s);
   days = secs/86400ul;
   secs = secs%86400ul;
   add_days(y, m, d, days);
   *h = secs/3600ul;
   secs = secs%3600ul;
   *mi = secs/60ul;
   *s = secs%60ul;
} /* end add_secs() */


extern X2C_INT32 TimeConv_Compare(struct SysClock_DateTime dl,
                struct SysClock_DateTime dr)
{
   X2C_INT32 r;
   if (!(SysClock_IsValidDateTime(dl) && SysClock_IsValidDateTime(dr))) {
      return 0l;
   }
   r = (X2C_INT32)dl.year-(X2C_INT32)dr.year;
   if (r) return r;
   r = (X2C_INT32)dl.month-(X2C_INT32)dr.month;
   if (r) return r;
   r = (X2C_INT32)dl.day-(X2C_INT32)dr.day;
   if (r) return r;
   r = (X2C_INT32)dl.hour-(X2C_INT32)dr.hour;
   if (r) return r;
   r = (X2C_INT32)dl.minute-(X2C_INT32)dr.minute;
   if (r) return r;
   r = (X2C_INT32)dl.second-(X2C_INT32)dr.second;
   if (r) return r;
   return (X2C_INT32)dl.fractions-(X2C_INT32)dr.fractions;
} /* end Compare() */


extern X2C_CARD32 TimeConv_SubDateDays(struct SysClock_DateTime dl,
                struct SysClock_DateTime dr)
{
   X2C_INT32 r;
   if (!(SysClock_IsValidDateTime(dl) && SysClock_IsValidDateTime(dr))) {
      return 0ul;
   }
   r = TimeConv_Compare(dl, dr);
   if (r<=0l) return 0ul;
   return sub_days(dl, dr);
} /* end SubDateDays() */


extern X2C_CARD32 TimeConv_SubDateSecs(struct SysClock_DateTime dl,
                struct SysClock_DateTime dr)
{
   X2C_INT32 r;
   if (!(SysClock_IsValidDateTime(dl) && SysClock_IsValidDateTime(dr))) {
      return 0ul;
   }
   r = TimeConv_Compare(dl, dr);
   if (r<=0l) return 0ul;
   return sub_secs(dl, dr);
} /* end SubDateSecs() */

static struct SysClock_DateTime FirstDate;

static struct SysClock_DateTime SysFirstDate;


extern void TimeConv_AddDateDays(struct SysClock_DateTime D, X2C_CARD32 days,
                 struct SysClock_DateTime * res)
{
   X2C_CARD32 d0;
   X2C_CARD32 m;
   X2C_CARD32 y;
   *res = FirstDate;
   if (!SysClock_IsValidDateTime(D)) return;
   y = D.year;
   m = D.month;
   d0 = D.day;
   add_days(&y, &m, &d0, days);
   *res = D;
   res->year = y;
   res->month = m;
   res->day = d0;
} /* end AddDateDays() */


extern void TimeConv_AddDateSecs(struct SysClock_DateTime D, X2C_CARD32 secs,
                 struct SysClock_DateTime * res)
{
   X2C_CARD32 s;
   X2C_CARD32 mi;
   X2C_CARD32 h;
   X2C_CARD32 d0;
   X2C_CARD32 m;
   X2C_CARD32 y;
   *res = FirstDate;
   if (!SysClock_IsValidDateTime(D)) return;
   y = D.year;
   m = D.month;
   d0 = D.day;
   h = D.hour;
   mi = D.minute;
   s = D.second;
   add_secs(&y, &m, &d0, &h, &mi, &s, secs);
   res->year = y;
   res->month = m;
   res->day = d0;
   res->hour = h;
   res->minute = mi;
   res->second = s;
   res->fractions = D.fractions;
   res->zone = D.zone;
   res->SummerTimeFlag = D.SummerTimeFlag;
} /* end AddDateSecs() */


extern X2C_CARD32 TimeConv_TheDayNumber(struct SysClock_DateTime d)
{
   if (!SysClock_IsValidDateTime(d)) return 0ul;
   return the_day(d.year, d.month, d.day);
} /* end TheDayNumber() */


extern X2C_CARD32 TimeConv_WeekDay(struct SysClock_DateTime d)
{
   return TimeConv_TheDayNumber(d)%7ul;
} /* end WeekDay() */


extern X2C_CARD32 TimeConv_TheFractionNumber(struct SysClock_DateTime d)
{
   X2C_CARD32 r;
   if (!SysClock_IsValidDateTime(d)) return 0ul;
   r = d.hour*3600ul+d.minute*60ul+d.second;
   return r*100ul+d.fractions;
} /* end TheFractionNumber() */


extern X2C_CARD32 TimeConv_time(void)
{
   struct SysClock_DateTime c;
   if (!SysClock_CanGetClock()) return 0ul;
   SysClock_GetClock(&c);
   return TimeConv_SubDateSecs(c, SysFirstDate);
} /* end time() */


extern X2C_CARD32 TimeConv_millisecs(void)
{
   struct SysClock_DateTime c;
   X2C_CARD32 r;
   if (!SysClock_CanGetClock()) return 0ul;
   SysClock_GetClock(&c);
   r = c.hour*3600ul+c.minute*60ul+c.second;
   return (r*100ul+c.fractions)*10ul;
} /* end millisecs() */


extern void TimeConv_unpack(struct SysClock_DateTime * d, X2C_CARD32 secs)
{
   TimeConv_AddDateSecs(SysFirstDate, secs, d);
} /* end unpack() */


extern void TimeConv_pack(struct SysClock_DateTime d, X2C_CARD32 * secs)
{
   X2C_INT32 r;
   *secs = 0ul;
   if (!SysClock_IsValidDateTime(d)) return;
   r = TimeConv_Compare(d, SysFirstDate);
   if (r<=0l) return;
   d.zone = 0l;
   d.fractions = 0ul;
   d.SummerTimeFlag = 0;
   *secs = TimeConv_SubDateSecs(d, SysFirstDate);
} /* end pack() */


extern X2C_CARD32 TimeConv_weekday0(X2C_CARD32 time0)
{
   struct SysClock_DateTime d;
   TimeConv_unpack(&d, time0);
   return TimeConv_WeekDay(d);
} /* end weekday() */


extern void TimeConv_BEGIN(void)
{
   static int TimeConv_init = 0;
   if (TimeConv_init) return;
   TimeConv_init = 1;
   SysClock_BEGIN();
   FirstDate.month = 1ul;
   FirstDate.day = 1ul;
   FirstDate.hour = 0ul;
   FirstDate.minute = 0ul;
   FirstDate.second = 0ul;
   FirstDate.fractions = 0ul;
   FirstDate.zone = 0l;
   FirstDate.SummerTimeFlag = 0;
   FirstValidYear = 0ul;
   FirstDate.year = FirstValidYear;
   if (!SysClock_IsValidDateTime(FirstDate)) {
      FirstValidYear = 1ul;
      FirstDate.year = FirstValidYear;
   }
   SysFirstDate.year = 1970ul;
   SysFirstDate.month = 1ul;
   SysFirstDate.day = 1ul;
   SysFirstDate.hour = 0ul;
   SysFirstDate.minute = 0ul;
   SysFirstDate.second = 0ul;
   SysFirstDate.fractions = 0ul;
   SysFirstDate.zone = 0l;
   SysFirstDate.SummerTimeFlag = 0;
}

