/* XDS v2.51: Copyright (c) 1999-2003 Excelsior, LLC. All Rights Reserved. */
/* "@(#)xrM2MM.c May 10 15:18:12 2005" */
#include "xrM2MM.h"
#define xrM2MM_C_
#include "xmRTS.h"
#include "xrMM.h"

#define LINK_SZ sizeof(struct X2C_LINK_STR)

#define GAP_SIZE 128


extern void X2C_ALLOCATE(X2C_ADDRESS * a, size_t size)
{
   X2C_LINK l;
   *a = 0;
   if (size==0u) return;
   xrMM_allocate(&l, size, 0);
   if (l==0) return;
   l->_0.tags |= 0x8000ul;
   l->_.td = x2c_td_null;
   *a = (X2C_ADDRESS)((X2C_ADDRESS)(X2C_ADDRESS)l+(X2C_INT32)
                sizeof(struct X2C_LINK_STR));
} /* end X2C_ALLOCATE() */


extern void X2C_DEALLOCATE(X2C_ADDRESS * a)
{
   X2C_LINK l;
   xrMM_Block x;
   X2C_CARD32 sz;
   if (*a==0) return;
   l = (X2C_LINK)(X2C_ADDRESS)((X2C_ADDRESS)*a-(X2C_INT32)
                sizeof(struct X2C_LINK_STR));
   if (l->_.td->res!=0x093678150ul) X2C_ASSERT_F(100ul);
   if ((0x8000ul & l->_0.tags)) {
      if ((l->_0.tags&0xFFE00000ul)==0ul) {
         x = xrMM_getLargeObjBlock(l);
         if (x->magic!=305419896ul) X2C_ASSERT_F(101ul);
         sz = x->fsum;
         xrMM_free_block(x);
      }
      else {
         sz = xrMM_getHpObjSize(l);
         xrMM_dealloc(l);
      }
      X2C_usedmem -= sz;
      --X2C_objects;
   }
   else l->_0.tags &= ~0x4000ul;
   *a = 0;
} /* end X2C_DEALLOCATE() */


extern void X2C_DYNALLOCATE(X2C_ADDRESS * a, size_t size, size_t lens[],
                size_t dims)
{
   xrMM_Dynarr desc;
   *a = 0;
   X2C_ALLOCATE((X2C_ADDRESS *) &desc, xrMM_DynarrDescSize(dims));
   if (desc) {
      X2C_InitDesc(desc, &size, lens, dims);
      X2C_ALLOCATE(&desc->a, size);
      if (desc->a==0) X2C_DEALLOCATE((X2C_ADDRESS *) &desc);
      else *a = (X2C_ADDRESS)desc;
   }
} /* end X2C_DYNALLOCATE() */


extern void X2C_DYNDEALLOCATE(X2C_ADDRESS * a)
{
   xrMM_Dynarr d;
   if (*a) {
      d = (xrMM_Dynarr)*a;
      X2C_DEALLOCATE(&d->a);
      X2C_DEALLOCATE(a);
   }
} /* end X2C_DYNDEALLOCATE() */

static X2C_ADDRESS get_addr(size_t, X2C_ADDRESS *, size_t, size_t [],
                size_t);

typedef X2C_ADDRESS * PTR_TO_ADDR;


static X2C_ADDRESS get_addr(size_t dim, X2C_ADDRESS * free_addr, size_t size,
                 size_t lens[], size_t dims)
{
   X2C_CARD32 i;
   X2C_ADDRESS addr;
   PTR_TO_ADDR tmp_ptr;
   X2C_CARD32 tmp;
   addr = *free_addr;
   if (dim+1u==dims) {
      *free_addr = (X2C_ADDRESS)((X2C_ADDRESS)*free_addr+(X2C_INT32)
                (size*lens[dim]));
   }
   else {
      *free_addr = (X2C_ADDRESS)((X2C_ADDRESS)*free_addr+(X2C_INT32)
                (lens[dim]*4u));
      tmp = lens[dim]-1u;
      i = 0ul;
      if (i<=tmp) for (;; i++) {
         tmp_ptr = (PTR_TO_ADDR)(X2C_ADDRESS)((X2C_ADDRESS)addr+(X2C_INT32)
                (i*4ul));
         *tmp_ptr = get_addr(dim+1u, free_addr, size, lens, dims);
         if (i==tmp) break;
      } /* end for */
   }
   return addr;
} /* end get_addr() */


extern void X2C_DYNCALLOCATE(X2C_ADDRESS * a, size_t size, size_t lens[],
                size_t dims)
{
   X2C_CARD32 i;
   size_t full_size;
   X2C_ADDRESS addr;
   X2C_ADDRESS free_addr;
   X2C_CARD32 tmp;
   full_size = size*lens[dims-1u];
   tmp = dims;
   i = 2ul;
   if (i<=tmp) for (;; i++) {
      full_size = (full_size+4u)*lens[dims-i];
      if (i==tmp) break;
   } /* end for */
   X2C_ALLOCATE(a, full_size);
   if (*a) {
      free_addr = *a;
      addr = get_addr(0u, &free_addr, size, lens, dims);
   }
} /* end X2C_DYNCALLOCATE() */


extern void X2C_DYNCDEALLOCATE(X2C_ADDRESS * a)
{
   if (*a) X2C_DEALLOCATE(a);
} /* end X2C_DYNCDEALLOCATE() */

